window.Gleam.initSearch([{"doc":"testbldr","title":"testbldr","content":"# testbldr\n\n[![Package Version](https://img.shields.io/hexpm/v/testbldr)](https://hex.pm/packages/testbldr)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/testbldr/)\n\nThis library is a dead simple set of utilities for building test suites programatically.\nMost of the time it makes sense to have one test signature per test, nad have those tests\nautomatically discovered and run.\nOther times you may want to read test cases in from files, json responses, etc. \nThis library is for the second case.\n\n```gleam\nimport testbldr\n\npub fn main() {\n    testbldr.new\n    |&gt; testbldr.tests(one_is_a_small_number())\n    |&gt; testbldr.run\n}\n\nfn one_is_a_small_number() -&gt; List(testbldr.Test) {\n  use number &lt;- list.map(list.range(2, 10))\n  let name = &quot;One is less than &quot; &lt;&gt; int.to_string(number)\n  let test = fn() {\n    case 1 &lt; number {\n      True -&gt; testbldr.pass()\n      False -&gt; testbldr.fail(&quot;Shockingly 1 &gt;&quot; &lt;&gt; int.to_string(number))\n    }\n  }\n  #(name, test)\n}\n```\n","url":"index.html"},{"doc":"testbldr","title":"Test","content":"pub type Test =\n  #(String, fn() -&gt; TestOutcome)\n A test has a name and a body (a function which returns a TestOutcome)\n\nSynonyms:\ntestbldr.Test\ntestbldr Test","url":"testbldr.html#Test"},{"doc":"testbldr","title":"TestOutcome","content":"pub type TestOutcome {\n  Pass\n  Fail(msg: String)\n}\n A test can either pass or fail with a given reason\nPass\n\n\nFail(msg: String)\n\n\nSynonyms:\ntestbldr.TestOutcome\ntestbldr TestOutcome","url":"testbldr.html#TestOutcome"},{"doc":"testbldr","title":"TestSuite","content":"pub type TestSuite =\n  List(Test)\n The list of tests to run\n\nSynonyms:\ntestbldr.TestSuite\ntestbldr TestSuite","url":"testbldr.html#TestSuite"},{"doc":"testbldr","title":"new","content":"pub const new: List(#(String, fn() -&gt; TestOutcome)) = []\n New test suite is just an empty list\nSynonyms:\ntestbldr.new\ntestbldr new","url":"testbldr.html#new"},{"doc":"testbldr","title":"fail","content":"pub fn fail(msg: String) -&gt; TestOutcome\n Let a test fail\nSynonyms:\ntestbldr.fail\ntestbldr fail","url":"testbldr.html#fail"},{"doc":"testbldr","title":"named","content":"pub fn named(name: String, new_test: fn() -&gt; TestOutcome) -&gt; #(\n  String,\n  fn() -&gt; TestOutcome,\n)\n Creates a new test with the given name\nSynonyms:\ntestbldr.named\ntestbldr named","url":"testbldr.html#named"},{"doc":"testbldr","title":"pass","content":"pub fn pass() -&gt; TestOutcome\n Let a test pass\nSynonyms:\ntestbldr.pass\ntestbldr pass","url":"testbldr.html#pass"},{"doc":"testbldr","title":"run","content":"pub fn run(input: List(#(String, fn() -&gt; TestOutcome))) -&gt; Nil\n Run the tests and print the test run output\nSynonyms:\ntestbldr.run\ntestbldr run","url":"testbldr.html#run"},{"doc":"testbldr","title":"test","content":"pub fn test(input: List(#(String, fn() -&gt; TestOutcome)), name: String, new_test: fn() -&gt;\n    TestOutcome) -&gt; List(#(String, fn() -&gt; TestOutcome))\n Add a single test to the test suite \nSynonyms:\ntestbldr.test\ntestbldr test","url":"testbldr.html#test"},{"doc":"testbldr","title":"tests","content":"pub fn tests(input: List(#(String, fn() -&gt; TestOutcome)), new_tests: List(\n    #(String, fn() -&gt; TestOutcome),\n  )) -&gt; List(#(String, fn() -&gt; TestOutcome))\n Add a list of tests to the test suite\nSynonyms:\ntestbldr.tests\ntestbldr tests","url":"testbldr.html#tests"},{"doc":"testbldr","title":"testbldr","content":"","url":"testbldr.html"}]);